package net.postchain.rell.codegen

import assertk.all
import assertk.assertions.startsWith
import org.junit.jupiter.api.Test
import assertk.assertThat
import assertk.assertions.contains
import assertk.assertions.hasSize
import net.postchain.rell.base.utils.doc.DocSymbol
import net.postchain.rell.codegen.deps.ClassName
import net.postchain.rell.codegen.document.AbstractDocument
import net.postchain.rell.codegen.section.Entity

internal class AbstractDocumentTest{

    @Test
    fun `Dummy objects are formatted properly`() {
        val doc = TestDocument()
        doc.addSection(TestEntity("MyEntity", listOf("import1", "import2")))
        doc.addSection(TestEntity("YourEntity", listOf("import1")))

        val formatted = doc.format()
        println(formatted)

        //Assert startswith intro and package
        assertThat(formatted).all {
            startsWith("//")
            contains("import2")
            contains("MyEntity")
        }
        // Assert contains import1 ONCE
        assertThat(formatted.split("import1")).hasSize(2)
    }

}

class TestDocument : AbstractDocument("// Generated by codegen",  "net.postchain.test") {
    override fun formatPackageString(): String {
        return "package $module"
    }
    override fun formatImportString(className: ClassName): String {
        return "import ${className.toPackageName("net.postchain.test")}"
    }
}

class TestEntity(val name: String,
                 override val imports: List<String> = listOf(),
                 override val docSymbol: DocSymbol = DocSymbol.NONE,) : Entity {
    override val moduleName = "test"
    override fun format(): String = name
}